var $ = jQuery;
$(function() {


var jGroupSelector = $('select.SelectStudyGroup');

var jAppPrototype = $($.parseHTML	(	'<div class="AttachedGroup">\
										<div class="StudyGroupInfo"></div>\
										<button class="UnbindGroup">Отсоединить группу</button>\
										</div>'
									));


// var jListPrototype = 	$($.parseHTML	(	'<option></option>' ));



function getAppendedElement(id, StudyGroupName){
	var cell = jAppPrototype.clone();
	cell.attr('id', id);
	cell.children('div.StudyGroupInfo').html(StudyGroupName);
	return cell;
}

// function getListElement(id, StudyGroupName){
// 	var cell = jListPrototype.clone();
// 	cell.attr('value', id);
// 	cell.html(StudyGroupName);
// 	return cell;
// }



// Прикрепить группу
$('button.AttachGroupButton').click(function()
{
	var thisObj = $(this);
	var StudyGroupID = jGroupSelector.val();
	if (StudyGroupID <= 0) 
		return;
	var jSelected = jGroupSelector.children("option:selected");
	var StudyGroupName = jSelected.text();
	$(this).attr('disabled', true);
	$.post(
		URLdir + 'handler/map/BindGroup',
		{
			'StudyGroupID': StudyGroupID,
			'DisciplineID': DisciplineID
		},
		function(data)
		{
			data = $.parseJSON(data);
			if(data.success === true) {
				var flag = false;
				//TODO: too slow
				jGroupSelector.parent().next().children('div.AttachedGroup').each(function() {
					if ($(this).children('.StudyGroupInfo').html().localeCompare(StudyGroupName) == 1) {
						$(this).before(getAppendedElement(StudyGroupID, StudyGroupName));
						flag = true;
						return false;
					}
					return true;
				});
				if (!flag) {
					jGroupSelector.parent().next().append(getAppendedElement(StudyGroupID, StudyGroupName));
				}
				//jSelected.remove();
			}
			else 
				EventInspector_ShowMsg('Ошибка при добавление группы', 'error');
			thisObj.removeAttr('disabled');
		}
	);
});

// Отсоединить группу
$('div.AttachedGroupsList').on('click', '.UnbindGroup:not(disabled)', function()
{
	var thisObj = $(this);
	var GroupDIV = $(this).parent();
	var StudyGroupID = GroupDIV.attr('id');
	//var Name = $(this).siblings('.StudyGroupInfo').html();
	$(this).attr('disabled', true);
	$.post(
		URLdir + 'handler/map/UnbindGroup',
		{
			'StudyGroupID': StudyGroupID,
			'DisciplineID': DisciplineID
		},
		function(data)
		{
			data = $.parseJSON(data);
			if(data.success === true) {

				// var flag = false;

				// jGroupSelector.children(':gt(0)').each(function() {
				// 	if ($(this).html().localeCompare(Name) == 1) {
				// 		$(this).before(getListElement(StudyGroupID, Name));
				// 		flag = true;
				// 		return false;
				// 	}
				// 	return true;
				// });
				// if (!flag) {
				// 	jGroupSelector.append(getListElement(DisciplineID, Name));
				// }

				GroupDIV.remove();
				EventInspector_ShowMsg('Группа отсоединена', 'success');
			}
			else {
				EventInspector_ShowMsg('Ошибка при отсоединение группы', 'error');
				thisObj.removeAttr('disabled');
			}
		}	
	);
});


});
